/*
 * specNewton.h
 *
 * This file is part of CAMPARY Library
 *
 * Copyright (C) 2014 - 
 *
 * CAMPARY Library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * CAMPARY Library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with MultiPrecGPU Library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, 
 * Boston, MA  02110-1301  USA
 */
 
/* Contributors: Valentina Popescu valentina.popescu@ens-lyon.fr
 *               Mioara Joldes joldes@laas.fr
 */

#ifndef _specNewton_h
#define _specNewton_h

/****************************************************/
template<> __host__ __device__ void __forceinline__ invNewtonUp<1,1>(const float *x, float *res){ res[0] = 1./x[0]; }

/****************************************************/
template<> __host__ __device__ void __forceinline__ divNewton<1,1,1>(const float *x, const float *y, float *res){ res[0] = x[0] / y[0]; }

/****************************************************/
template<> __host__ __device__ void __forceinline__ sqrtInvNewton<1,1>(float const *x, float *res){ res[0] = 1/sqrt(x[0]); }

/****************************************************/
template<> __host__ __device__ void __forceinline__ sqrtNewton<1,1>(float const *x, float *res){ res[0] = sqrt(x[0]); }

/****************************************************/
template<> __host__ __device__ void __forceinline__ sqrtHeron<1,1>(float const *x, float *res){ res[0] = sqrt(x[0]); }

#endif
